CREATE OR REPLACE PACKAGE Pkg_Dynamic_2 IS

  -----------------------------------------------------------
  --  Sample package to test the 100%dynamic SQL features  --
  --                                                       --
  --  Author : Francois Degrelle                           --
  --                                                       --    
  -----------------------------------------------------------
  
  TYPE T1 IS TABLE OF VARCHAR2(4000) INDEX BY BINARY_INTEGER ;
  TYPE T2 IS TABLE OF T1 INDEX BY BINARY_INTEGER ;

  T_rowS T2 ;
  T_COLS T2 ;
  T_row  T1 ;
  GC$TName   Varchar2(30) ;

  PROCEDURE Generate_table
  (
     PC$Query IN  VARCHAR2
  ) ;

  PROCEDURE Show_Table ;

  PROCEDURE Get_row
  (
     PN$row   IN  PLS_INTEGER,
	 PR$row   OUT T1
  ) ;
  
  FUNCTION Delete_row
  (
     PN$row   IN  PLS_INTEGER
  ) RETURN Boolean ;
  
  FUNCTION Insert_row
  (
     PC$Values   IN  VARCHAR2
  ) RETURN Boolean ;
  
  
  FUNCTION Update_row
  (
     PN$row      IN PLS_INTEGER,
	 PC$Values   IN  VARCHAR2
  ) RETURN Boolean ;          

  
  PROCEDURE OutPut
  (
    PC$String IN VARCHAR2
  ) ;

  
END Pkg_Dynamic_2 ;
/
